#version 460

#include "/lib/settings.glsl"

#if FOG_STRENGTH
	uniform float rainStrength;

	uniform int isEyeInWater;
	uniform float blindness;

	uniform float far;

	out float fogStrength;
#endif

out vec2 texcoord;

in vec3 vaPosition;
in vec2 vaUV0;
uniform mat4 projectionMatrix;

void main() {
	gl_Position = projectionMatrix * vec4(vaPosition, 1.0);

	texcoord = vaUV0;

	#if FOG_STRENGTH
		fogStrength = (FOG_STRENGTH * 0.1 + rainStrength * RAIN_FOG + isEyeInWater * WATER_FOG + blindness * BLINDNESS_FOG) / pow(far, 3.0);
	#endif
}