#version 460

#include "/lib/settings.glsl"

#ifdef SHARPEN
#endif

/* DRAWBUFFERS:0 */

out vec3 outColor0;

uniform sampler2D colortex0;

in vec2 texcoord;

float luminance(in vec3 color) {
	return dot(color, vec3(0.2125, 0.7154, 0.0721));
}

uniform float viewWidth;
uniform float viewHeight;

vec3 getSharpening(in vec3 color) {
	const vec2 coord = 1.0 / vec2(viewWidth, viewHeight);

	const vec2 offset[4] = vec2[4](
		vec2(coord.x, coord.y),
		vec2(coord.x, -coord.y),
		vec2(-coord.x, coord.y),
		vec2(-coord.x, -coord.y)
	);

	vec3 sum;

	for(int i = 0; i < 4; i++) {
		sum += texture(colortex0, texcoord + offset[i]).rgb;
	}

	return clamp(dot(color - (sum - color) / 3.0, vec3(0.333333)), -0.003, 0.003) * pow(luminance(color), 0.5) * normalize(color.rgb + 0.00000001) * SHARPENING + color;
}

void main() {
	vec3 color = texture(colortex0, texcoord).rgb;

	outColor0 = getSharpening(color);
}