#version 460

out vec4 tintColor;

out vec3 normal;

uniform vec3 fogColor;

in vec3 vaPosition;
in vec4 vaColor;
in vec3 vaNormal;
uniform mat4 modelViewMatrix;
uniform mat4 projectionMatrix;
uniform mat3 normalMatrix;

uniform float far;
uniform float near;

void main() {
	vec4 position = projectionMatrix * modelViewMatrix * vec4(vaPosition, 1.0);

	gl_Position = position;

	float depth = position.z / position.w;
	float linearDepth = 2.0 * near * far / (far + near - (2.0 * depth - 1.0) * (far - near));

	tintColor = vec4(vaColor.rgb + fogColor, vaColor.a * clamp(linearDepth * 0.01, 0.0, 1 - linearDepth * 0.0075));
	//tintColor = vec4(mix(vaColor.rgb, fogColor, 0.75), vaColor.a * 0.75);

	normal = normalize(normalMatrix * vaNormal) * 0.5 + 0.5;
}

/*
uniform float rainStrength;
uniform int isEyeInWater;
uniform float blindness;

void main() {
	float fogStrength = (2 * 0.1 + rainStrength * RAIN_FOG + isEyeInWater * WATER_FOG + blindness * BLINDNESS_FOG) / (far * far * far) * 25000000;

	vec4 position = projectionMatrix * modelViewMatrix * vec4(vaPosition, 1.0);

	gl_Position = position;

	float depth = position.z / position.w;
	float linearDepth = 2.0 * near * far / (far + near - (2.0 * depth - 1.0) * (far - near));

	tintColor = vec4(vaColor.rgb + fogColor, clamp(vaColor.a * (1 - linearDepth * 0.01 * fogStrength), 0.0, 0.5));
	//tintColor = vec4(mix(vaColor.rgb, fogColor, 0.75), vaColor.a * 0.75);

	normal = normalize(normalMatrix * vaNormal) * 0.5 + 0.5;
}
*/