#version 460

out vec4 tintColor;

out vec2 texcoord;

out vec2 lmcoord;

out vec3 normal;

in vec3 vaPosition;
in vec4 vaColor;
in vec2 vaUV0;
in vec3 vaNormal;
uniform mat4 modelViewMatrix;
uniform mat4 projectionMatrix;
uniform mat3 normalMatrix;
uniform vec3 chunkOffset;

void main() {
	gl_Position = projectionMatrix * modelViewMatrix * vec4(vaPosition + chunkOffset, 1.0);

	texcoord = vaUV0;

	tintColor = vaColor;

	normal = normalize(normalMatrix * vaNormal) * 0.5 + 0.5;
}