#version 460 compatibility

#include "/lib/settings.glsl"

in vec3 mc_Entity;

out vec4 tintColor;

out vec2 texcoord;

out vec2 lmcoord;

out vec3 normal;

out float emission;

float getEmission(in float blockEntityId) {
	if(blockEntityId == 1.0) {
		return 1.0;
	} else {
		return 0.0;
	}
}

float getIsRedstoneBlock(in float blockEntityId) {
	#ifdef GLOWING_REDSTONE_BLOCK
		if(blockEntityId == 2.0) {
			return 1.0;
		} else {
			return 0.0;
		}
	#else
		return 0.0;
	#endif
}

float getIsEmeraldBlock(in float blockEntityId) {
	#ifdef GLOWING_EMERALD_BLOCK
		if(blockEntityId == 3.0) {
			return 1.0;
		} else {
		 return 0.0;
		}
	#else
		return 0.0;
	#endif
}

float getIsLapisBlock(in float blockEntityId) {
	#ifdef GLOWING_LAPIS_BLOCK
		if(blockEntityId == 4.0) {
			return 1.0;
		} else {
			return 0.0;
		}
	#else
		return 0.0;
	#endif
}

/*
out float fogStrength;

uniform float rainStrength;
uniform int isEyeInWater;
uniform float blindness;

in vec2 mc_midTexCoord;

out vec2 midTexCoord;

out float depth;

uniform float far;
*/

void main() {
	gl_Position = ftransform();

	texcoord = gl_MultiTexCoord0.xy;

	tintColor = gl_Color * vec4(1, 1, 1, 0.5);

	/*
	vec4 position = ftransform();
	
	gl_Position = position;

	fogStrength = (FOG_STRENGTH * 0.25 + rainStrength * RAIN_FOG + isEyeInWater * WATER_FOG + blindness * BLINDNESS_FOG) / pow(far, 6.0) / (1 - pow(position.x / far, 2.0));

	depth = position.z / position.w;

	midTexCoord = mc_midTexCoord;
	*/

	lmcoord = (gl_TextureMatrix[1] * gl_MultiTexCoord1).xy;

	normal = normalize(gl_NormalMatrix * gl_Normal) * 0.5 + 0.5;

	emission = min(getEmission(mc_Entity.r) + getIsRedstoneBlock(mc_Entity.r) + getIsEmeraldBlock(mc_Entity.r) + getIsLapisBlock(mc_Entity.r), 1.0);
}